program PORT378; {$C-,U-} (* Suppresses False key presses *)

(* This is a Printer Port Controller *)

CONST CONTROL = $378; (* Address of Printer Port *)
      A=1; B=2; C=4; D=8; E=16; F=32; G=64; H=128; (* Mask for Control Bits *)

TYPE MENU = (QUIT, ERROR);

VAR Key: CHAR;
    Choice: MENU;
    Mask, Ctrl_Out: INTEGER;

begin (* MAIN *)

   Port[CONTROL] := 0; (* Clear Output *)
   Ctrl_Out := 0;

   Clrscr; GotoXY (1,9); (* Display Menu *)
   WriteLn ('             ͻ');
   WriteLn ('                         PRINTER PORT 378 CONTROLLER            ');
   WriteLn ('             ͹');
   WriteLn ('              OUTPUT    A:0  B:0  C:0  D:0  E:0  F:0  G:0  H:0  ');
   WriteLn ('             ͹');
   WriteLn ('              A-H: TOGGLE BIT                           Q: QUIT ');
   WriteLn ('             ͼ');

   repeat

      Choice := ERROR; (* Set Menu Choice to NUL *)
      Mask := 0; (* Clear Mask *)

      if Keypressed then (* Get Choice *)
      begin

         Read (KBD, Key);

         case Key of
            'A', 'a': Mask := A;
            'B', 'b': Mask := B;
            'C', 'c': Mask := C;
            'D', 'd': Mask := D;
            'E', 'e': Mask := E;
            'F', 'f': Mask := F;
            'G', 'g': Mask := G;
            'H', 'h': Mask := H;
            'Q', 'q': Choice := QUIT;
         end; (* CASE *)

      end; (* IF *)

      if (Mask > 0) then (* Toggle Bit *)
      begin

         if ((Ctrl_Out AND Mask) = Mask) then Ctrl_Out := Ctrl_Out - Mask else Ctrl_Out := Ctrl_Out + Mask;

         GotoXY (28,12); Write ((Ctrl_Out AND A) DIV A);
         GotoXY (33,12); Write ((Ctrl_Out AND B) DIV B);
         GotoXY (38,12); Write ((Ctrl_Out AND C) DIV C);
         GotoXY (43,12); Write ((Ctrl_Out AND D) DIV D);
         GotoXY (48,12); Write ((Ctrl_Out AND E) DIV E);
         GotoXY (53,12); Write ((Ctrl_Out AND F) DIV F);
         GotoXY (58,12); Write ((Ctrl_Out AND G) DIV G);
         GotoXY (63,12); Write ((Ctrl_Out AND H) DIV H);

         Port [CONTROL] := Ctrl_Out;

      end; (* IF *)

   until (Choice = QUIT);

   ClrScr;
   Port[CONTROL] := 0; (* Clear Output *)

end. (* MAIN *)