program Scroller; (* 18-08-91 *) {$C-,U-}

(* This procedure provides demostrations for the Aplhanumeric Scroller *)

const LAST_DISPLAY_DIGIT = 15;

var Key: Char;
    Display_Message: STRING [16];
    Loop: Integer;

procedure alpha_write (Character: Char; Address: Integer);

(* This procedure writes a Character to one of the Displays Digits *)

const ALPHA_CHARACTER = $304; (* Addresses of Display *)
      ALPHA_ADDRESS = $305;
      DISABLE_UNITS = 60; (* 32 + 16 + 8 + 4 *)
      CURSOR_OFF = 128;

var Active_Unit, Digit: Integer;

begin (* alpha_write *)

    case Address of
        0..3:   Active_Unit := 32;
        4..7:   Active_Unit := 16;
        8..11:  Active_Unit := 8;
        12..15: Active_Unit := 4;
    end; (* case *)

    case Address of
        0,4,8,12:  Digit := 3;
        1,5,9,13:  Digit := 2;
        2,6,10,14: Digit := 1;
        3,7,11,15: Digit := 0;
    end; (* case *)

    if ((Character >= 'a') or (Character <= 'z')) then
        Character := Upcase (Character);

    Port [ALPHA_ADDRESS] := (DISABLE_UNITS - Active_Unit) + Digit;
    Port [ALPHA_CHARACTER] := Ord (Character) + CURSOR_OFF;
    Port [ALPHA_ADDRESS] := DISABLE_UNITS + Digit;
    Port [ALPHA_CHARACTER] := CURSOR_OFF;

end; (* alpha_write *)

procedure alpha_scroll;

(* This procedure Scrolls a Message of up to 255 Characters on the Alphanumeric
   Display Module *)

const MESSAGE_LENGTH = 127; (* Maximum possible! *)
      SPEED = 350; (* Lower figure for faster Scrolling *)

var Position, Pointer, Place: Integer;
    Message: String [MESSAGE_LENGTH];

begin (* alpha_scroll *)

    Window (9,12,72,13); ClrScr;

    Read (Message);

    repeat

        for Position := 1 to Length (Message) do

            if NOT Keypressed then
            begin

                Pointer := Position;

                for Place := 0 to LAST_DISPLAY_DIGIT do
                begin

                    alpha_write (Message [Pointer], Place);
                    Pointer := Pointer + 1;

                    if (Pointer > Length (Message)) then Pointer := 1;

                end; (* Loop *)

                delay (SPEED);

            end; (* If *)

    until Keypressed;

    Window (1,1,80,25);

end; (* alpha_scroll *)

begin (* main *)

    Key := ' ';

    Clrscr; GotoXY (1,7);
    Writeln ('       ͻ');
    Writeln ('                       ALPHANUMERIC DISPLAY MODULE DEMO                ');
    Writeln ('       ͹');
    Writeln ('                           Message to be Scrolled:                     ');
    Writeln ('       Ķ');
    Writeln ('                                                                       ');
    Writeln ('                                                                       ');
    Writeln ('       ͹');
    Writeln ('        Message to be Displayed (Maximum Length 16):                   ');
    Writeln ('       ͹');
    Writeln ('        S: Scroll, D: Display                                  Q: Quit ');
    Writeln ('       ͼ');

    repeat

        GotoXY (32,17);

        if Keypressed then
        begin

            Read (KBD, Key);

            if ((Key = 'S') or (Key = 's')) then alpha_scroll;

            if ((Key = 'D') or (Key = 'd')) then
            begin

                GotoXY (55,15); Write ('                ');
                Display_Message := '                ';

                GotoXY (55,15);
                Readln (Display_Message);

                for Loop := 0 to LAST_DISPLAY_DIGIT do
                    alpha_write (Display_Message [Loop+1], Loop);

            end; (* Inner If *)

        end; (* Outer If *)

    until ((Key = 'Q') or (Key = 'q'));

    Clrscr;

end. (* Main *)